$INTERFACE U1FLU2                                             98/12/01
$REM LU
  $N='NF'
  $XM='XM'
  $XR='XR'
  $HR='HR'
  $U1='U1'
  $U2='U2'
  $U3='U3'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,5,INT,2,NO)
  $ADD(INIT)
    MF=$MF
  $ENDADD
  $HERF='L'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8',3)
  $IF(MET=7)
    $HELP
      PARAMETER ETA FOR VARIABLE METRIC UPDATES
    $CHECK(ETA3,'1.0$P 0',REAL,3)
  $ENDIF
  $UPDATE='R'
  $IF(MET=1) $UPDATE='E'
  $IF(MET=4) $UPDATE='E'
  $IF(UPDATE='E')
    $GM='GM'
    $GR='GR'
    $DR='DR'
    $IHR='IHR'
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$U1($MF)\$U2($MF)')
    $ADD(INTEGER,'\$IX($NF)\IMD\METS\MX')
$REM    $TYPE='L'
    $HELP
      TYPE OF METHOD:
        L - LINE SEARCH
        G - GENERAL TRUST REGION
    $CHECK(TYPE,'L','L\G',2,NO)
    $IF(TYPE='L')
      $HELP
        MATRIX DECOMPOSITION
          M - NO DECOMPOSITION
          I - INVERSION
      $CHECK(DECOMP,'I','M\I',2,NO)
      $IF(DECOMP='M')
        $NUMBER=3
        $ADD(REAL,'\$DR($MF)\$U3($MF)')
      $ELSE
        $NUMBER=1
      $ENDIF
    $ELSE
      $DECOMP='M'
      $HELP
         METHOD
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
      $CHECK(NUMBER,3,'3\4\5\6',2,NO)
      $ADD(REAL,'\$DR($MF)\$U3($MF)')
    $ENDIF
  $ELSE
    $TYPE='L'
    $DECOMP='I'
    $ADD(REAL,'\$XM(2*$NF*$MF)\$XR($MF*($MF+1))\$HR($MF*(2*$MF+1))&
    \$U1(2*$MF)\$U2(2*$MF)\$U3(2*$MF)')
    $ADD(INTEGER,'\$IX($NF)\IMD\METS\MX')
  $ENDIF
  $ISNF=0
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
  $ELSE
    $HELP
      SPECIFICATION OF THE SEARCH:
        B - BASIC LINE SEARCH
        H - HAGER LINE SEARCH
        M - LINE SEARCH WITH TRUST REGION BOUND
        N - NONMONOTONE LINE SEARCH
    $CHECK(SEARCH,'B','B\H\M\N',3,NO)
    $IF(SEARCH='H')
      $HELP
        MAXIMUM NUMBER OF TESTS ON STEPLENGTH
      $CHECK(MTESX,5,INT,4)
      $HELP
        MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
      $CHECK(MTESF,5,INT,4)
      $HELP
        LOWER BOUND FOR STEPLENGTH
      $CHECK(TOLX,'1.0$P-18',REAL,3)
      $HELP
        LOWER BOUND FOR FUNCTION DECREASE
      $CHECK(TOLF,'1.0$P-18',REAL,3)
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
  $ENDIF
$REM  $JHLP=1
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  IF (ITERM.NE.0) GOTO $90
*
*     -------------------------------------
*     LIMITED MEMORY VARIABLE METRIC METHOD
*     TEMPLATE : U1FLU2
*     -------------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  METS=MET
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF(TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF(TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $90
  $IF(CONSTR='C')
    IF (RMAX.GT.ZERO) THEN
    $SUBST('UYRM$(CONSTR)0')
    ENDIF
  $ENDIF
$L=$30 ; $LABEL
  IF (IREST.GT.0) THEN
  TUXX='UNIT    '
  CALL UYSET3
  MX=0
  ENDIF
  IF (ITERM.NE.0) GOTO $90
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(DECOMP='I') $DECOMG='G'
  $MAT='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GOTO $90
  IF (IREST.NE.0) GOTO $30
$L=$60 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$70 ; $LABEL
  $SUBST('UZLINS')
  $IF(SEARCH='H')
    GO TO ($78,$72,$74) ISB+1
$L=$72 ; $LABEL
    ASSIGN $70 TO IMD
    GO TO $10
$L=$74 ; $LABEL
    $SUBST('US1LUP')
    GO TO ($70,$76) ISB+1
$L=$76 ; $LABEL
    ASSIGN $74 TO IMD
    GOTO $10
  $ELSE
    GO TO ($78,$72) ISB+1
$L=$72 ; $LABEL
    ASSIGN $70 TO IMD
    $IF(CONSTR='C')
      $IF(TYPE='G')
        CALL UXVDIR(NF,R,$S,$XO,$X)
      $ELSE
        CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
      $ENDIF
      $SUBST('UCBS04')
    $ELSE
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ENDIF
    GOTO $10
  $ENDIF
$L=$78 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  MET=METS
  $IHLP=1
  $IF(UPDATE='R') $IHLP=3
  $SUBST('UYTR$(CONSTR)D')
  $SUBST('UULB$(DECOMP)$IHLP')
$L=$75 ; $LABEL
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  MET=METS
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FLU2'
  $ENDADD
  $EXIT
