$INTERFACE U1FSE3                                             99/12/01
$REM LU
  $N='NF'
  $NN='NC'
  $XV='XV'
  $GV='GV'
  $HERF='V'
$REM  $ADD(REAL,'\$CFO($NC+1)\$CZO($NC)')
  $ADD(REAL,'\$CFO($NC+1)')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $IF(KBF>0) $CONSTR='C'
  $ISNF=0
  $ITRG=1
  $GNS=GN
  $MODP='FF'
  $ADD(INTEGER,'\ISNCS')
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $IF(MODEL='A?') $ADD(INTEGER,'\ISNAS')
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $MOS1=0
  $IF(TYPE='L')
    $HELP
      LINEAR EQUATIONS FOR DIRECTION DETERMINATION
        K - KKT SYSTEM
        Z - NULL SPACE ELIMINATION
    $CHECK(DECOMP,'K','K\Z',2,NO)
  $ELSEIF(TYPE='G')
    $DECOMP='Z'
    $HELP
      DIAGONAL PRECONDITIONING
        1 - INDEFINITE PRECONDITIONING - NORMAL EQUATION APPROACH
        2 - INDEFINITE PRECONDITIONING - AUGMENTED SYSTEM APPROACH
    $CHECK(MOS2,1,'1\2',3)
    $NOS2=MOS2
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $IF(DECOMP='K')
    $HELP
       METHOD
         3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
         4 - INEXACT SOLUTION BY THE CONJUGATE RESIDUAL METHOD
         5 - INEXACT SOLUTION BY THE SYMMETRIC QMR METHOD
         6 - INEXACT SOLUTION BY THE NONSYMMETRIC CGS METHOD
    $CHECK(NUMBER,3,'3\4\5\6',2,NO)
    $HELP
      PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
             0 - PRECONDITIONING IS SUPPRESSED
       -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
                 EQUATION APPROACH.
             2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
                 SYSTEM APPROACH.
      MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
      MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
    $CHECK(MOS2,1,'-1\0\1\2',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-2) $NOS2=2
  $ELSEIF(DECOMP='Z')
    $HELP
      METHOD
        3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
            METHOD PRECONDITIONED BY THE NORMAL EQUATION.
    $CHECK(NUMBER,3,'3',2,NO)
    $HELP
      PRECONDITIONING THE REDUCED SYSTEM
            -1 - PRECONDITIONING BASED ON A DIAGONAL APPROXIMATION
                 OF THE HESSIAN MATRIX - NORMAL EQUATION APPROACH
            -2 - PRECONDITIONING BASED ON A DIAGONAL APPROXIMATION
                 OF THE HESSIAN MATRIX - AUGMENTED SYSTEM APPROACH
      MOS2 < 0 - UNIT MATRIX IN THE PRECONDITIONER
    $CHECK(MOS2,-1,'-2\-1',3)
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
  $ENDIF
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.1$P 0',REAL,4)
  $KDS=0
  $IF(TYPE='L')
    $HELP
      CHOICE OF THE MERIT STRATEGY:
        P - PENALTY FUNCTION
        M - MARKOV FILTER
        F - FLETCHER-LEYFFER FILTER
    $CHECK(MERIT,'P','P\M\F',2,NO)
    $IF(MERIT='P')
      $HELP
        MERIT FUNCTION
          0 - MERIT FUNCTION IS NOT USED
          1 - POWELL L1 PENALTY FUNCTION
          2 - L2 AUGMENTED LAGRANGIAN FUNCTION
          3 - L1 AUGMENTED LAGRANGIAN FUNCTION
          4 - HAN L1 PENALTY FUNCTION
          5 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
      $CHECK(MEP,2,'0\1\2\3\4\5\6',2)
      $IF(MEP=6) $KDS=1
      $IF(MEP=0) $KTERS=6
      $HELP
        USE OF CORRECTION STEP
          1 - BASIC STEP
          2 - CORRECTION STEP
      $CHECK(MEP1,1,'1\2',4)
      $HELP
        INITIAL LAGRANGE MULTIPLIERS
          1 - FROM THE PREVIOUS ITERATION
          2 - FROM THE LEAST SQUARES SOLUTION
      $CHECK(MEP2,1,'1\2',4)
      $MEP3=1
      $IF(MEP<>2) $MEP3=1
      $HELP
        FORM OF THE PENALTY TERM
          1 - BASIC PENALTY TERM
          2 - BOGGS-TOLLE PENALTY TERM
      $CHECK(MEP3,1,'1\2',4)
      $STEP=1
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
          1-UNIT INITIAL STEPSIZE
          2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR VM METHODS
          3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR CG METHODS
          4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
      $CHECK(INITS,1,'1\2\3\4',4)
    $ELSEIF(MERIT='F')
      $HELP
        MAXIMUM NUMBER OF FILTER SAMPLES
      $CHECK(MS,50,INT,3)
      $IF(MS<5) $MS=5
      $FS='FS'
      $ADD(REAL,'\$FS($MS,2)')
      $MEP=0
      $MEP1=0
      $MEP2=0
      $MEP3=0
      $STEP=7
      $INITS=1
      $ADD(INIT)
        INITS=$INITS
      $ENDADD
    $ELSEIF(MERIT='M')
      $FS='FS'
      $ADD(REAL,'\$FS(2)')
      $MEP=0
      $MEP1=0
      $MEP2=0
      $MEP3=0
      $STEP=8
      $INITS=1
      $ADD(INIT)
        INITS=$INITS
      $ENDADD
    $ENDIF
  $ELSEIF(TYPE='G')
    $MERIT='P'
    $HELP
      MERIT FUNCTION
        0 - MERIT FUNCTION IS NOT USED
        1 - POWELL L1 PENALTY FUNCTION
        2 - L2 AUGMENTED LAGRANGIAN FUNCTION
        3 - L1 AUGMENTED LAGRANGIAN FUNCTION
        4 - HAN L1 PENALTY FUNCTION
        5 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
    $CHECK(MEP,2,'0\1\2\3\4\5\6',2)
    $IF(MEP=6) $KDS=1
    $IF(MEP=0) $KTERS=6
    $MEP1=0
    $MEP2=0
    $MEP3=0
  $ENDIF
  $IF(HESF='D')
    $UPDATE='B'
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - RANK-ONE UPDATE
    $CHECK(MET,1,'1\2\3\4',3)
    $INITH=1
  $ELSE
    $UPDATE='B'
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        4 - SAFEGUARDED RANK ONE UPDATE
    $CHECK(MET,1,'1\4',3)
  $ENDIF
$REM  $IF(MODELA='YES')
$REM    $SUBST('UFSET2')
$REM    $ISNA=2
$REM    $ADD(INIT)
$REM      ISNA=2
$REM    $ENDADD
$REM  $ENDIF
  $MCL=NC
   MCL=NC
  $GN=GV
  $SN=S
  NDECF=0
  $SUBST('UCGS03')
  IF (IER.NE.0) THEN
  CALL UOERR1('U2FSE1',83)
  ITERM=-83
  GO TO $80
  ELSE IF (NC.GT.NCE) THEN
  CALL UOERR1('U2FSE1',84)
  ITERM=-84
  GO TO $80
  END IF
  $IDECC=0
  $IF(MEP1>1)
    $SUBST('UCESS1')
  $ELSEIF(MEP2>1)
    $SUBST('UCESS1')
  $ELSEIF(MEP3>1)
    $SUBST('UCESS1')
  $ELSEIF(DECOMP='K')
    $IF(NOS2=1) $SUBST('UCESS1')
  $ELSEIF(DECOMP='Z')
    $IF(NOS2=1) $SUBST('UCESS1')
  $ENDIF
  IF (ITERM.NE.0) THEN
  IF (ITERM.EQ.-85) TDXX='DENSE R.'
  GO TO $80
  ENDIF
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $ADD(SINIT)
    $IF(MOS2=0)
      CALL UXVSET(NC,1.0$P-8,$CZ)
    $ELSE
      CALL UXVSET(NC,0.0$P 0,$CZ)
    $ENDIF
  $ENDADD
  $IF(KBF>0) $SUBST('UYFPC1')
  $IF(MODELF='YES')
$REM    $NUM=3
  $ELSE
$REM    $NUM=4
  $ENDIF
  $IF(NOS2=2)
    $JOB=2
    $SUBST('UYSFIB')
  $ENDIF
  $IF(MEP1>1)
    $SUBST('UYSFSB')
  $ELSEIF(MEP2>1)
    $SUBST('UYSFSB')
  $ELSEIF(MEP3>1)
    $SUBST('UYSFSB')
  $ELSEIF(DECOMP='K')
    $IF(MOS2=1) $SUBST('UYSFSB')
  $ELSEIF(DECOMP='G')
    $IF(MOS2>0) $SUBST('UYSFSB')
  $ELSEIF(DECOMP='Z')
    $IF(NOS2=1) $SUBST('UYSFSB')
  $ENDIF
*
*     ----------------------
*     VARIABLE METRIC METHOD
*     TEMPLATE : U1FSE3
*     ----------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO3(0)
  FO=FMIN
  IF (ITERM.NE.0) GO TO $80
$L=$10 ; $LABEL
  $KD=1
  $LET='F'
  $SUBST('UP1$(MODP)3')
  $IF(MERIT='F')
    FC=CMAX
  $ELSEIF(MERIT='M')
    FC=CMAX
  $ELSE
    IF (ISNC.GT.0) CF(NC+1)=F$LET
  $ENDIF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  $IF(MEP2>1)
    IF (LD.EQ.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    $SUBST('UCSLG1')
    ENDIF
  $ELSEIF(MEP3>1)
    IF (LD.GE.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    $SUBST('UCSLG1')
    ENDIF
  $ELSEIF(MEP1>1)
    IF (LD.GE.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    ENDIF
  $ENDIF
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $IF(MEP3=1) $SUBST('UP0AF1')
        $IF(MEP3=2) $SUBST('UP0AF2')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $SUBST('UP0AF1')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='F')
    KS=1
    FS(1,1)=-ETA9
    FS(1,2)= MAX(ONE,TEN*FC)
  $ELSEIF(MERIT='M')
    FS(1)=-ETA9
    FS(2)= MAX(ONE,TEN*FC)
  $ENDIF
$L=$ 30 ; $LABEL
  $GN=GV
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(KBF>0)
    $ADD(INTEGER,'\IRESTS')
    IRESTS=IREST
    $SUBST('UYRMC0')
    IREST=IRESTS
  $ENDIF
$L=$ 40 ; $LABEL
  IF (IREST.GT.0) THEN
  TUXX='UNIT    '
  CALL UYSET3
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  CALL UXVCOP(NF,$X,$XV)
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINB(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(KBF>0)
    IF (SQRT(UXVDOT(NC,$S(NF+1),$S(NF+1))).GT.1.0D 6*SNORM)&
    CALL UXVSET(NC,ZERO,$S(NF+1))
  $ENDIF
  $SUBST('UD1T$(TYPE)3')
  $IF(KBF>0)
    CALL UXVINE(MC,$JCG)
    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
  $ENDIF
$REM  CALL UXVCOP(NC,$CZ,$CZO)
  $IF(TYPE='L')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $IF(MEP3=1) $SUBST('UP0AF1')
        $IF(MEP3=2) $SUBST('UP0AF2')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        R=ZERO
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $SUBST('UP0AF1')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(KBF>0)
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(NC+1,$CF,$CFO)
  $IF(MEP1>1)
    $SUBST('UCSLG2')
    IF (ITERS.EQ.5) GOTO $64
  $ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $IF(MEP1>1)
    IF (IPOM3.GT.0) THEN
    CALL UXUDIR(NF,R*R,$GS,$X,$X,$IX,KBF)
    ELSE IF (IPOM3.LT.0) THEN
    IF (R.EQ.ONE) LD=0
    ENDIF
  $ENDIF
  $SUBST('UCBS04')
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  ISNC=2
  $IF(KDA=1) LD=0
  $IF(KDC=1) LD=0
$REM  CALL UXVDIR(NC,R,$S(NF+1),$CZO,$CZ)
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
$REM  CALL UXVCOP(NC,$CZO,$CZ)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  CALL UXVDIR(NC,R,$S(NF+1),$CZ,$CZ)
$REM  IF (NIT.NE.LIT+1) THEN
$REM  CALL UXVSCL(NC,R,S(NF+1),S(NF+1))
$REM  CALL UXSCMD(NF,NC,MC,$CG,$ICG,$JCG,$S(NF+1),ONE,$GO,$GO)
$REM  ENDIF
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTRED')
$REM  $SUBST('UYTR$(CONSTR)D')
  $IF(KBF>0)
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GOTO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF(NC+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FN2')
  $GN=GNS
  $ADD(INIT)
    NXFU='U1FSE3'
  $ENDADD
  $EXIT
