$INTERFACE U1SSU1                                             97/12/01
$REM LU
  $N='NF'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD\METS')
  $JARA='S'
  $AGH='AGH'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $LU=0
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $IF(NA=NF)
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        E - GENERAL MATRIX FOR NONLINEAR EQUATIONS
    $CHECK(DECOMP,'E','A\E',2,NO)
  $ELSE
    $DECOMP='A'
  $ENDIF
  $IF(TYPE='L')
    $IF(DECOMP='A')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY SPARSE QR FACTORIZATION
           2 - EXACT SOLUTION BY SPARSE BUNCH-PARLETT FACTORIZATION
               OF AUGMENTED SYSTEM
           3 - INEXACT SOLUTION BY CGLS METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
      $CHECK(NUMBER,3,'1\2\3\4',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - EXACT SOLUTION BY SPARSE LU FACTORIZATION
           3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
           4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
           5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\3\4\5',2,NO)
      $IF(NUMBER>2)
        $HELP
          PRECONDITIONING TECHNIQUE
            ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
            ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
            ABS(MOS2)=2 - SSOR PRECONDITIONING
               MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
               MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                          BY PRECONDITIONED ITERATIVE PROCESS
        $CHECK(MOS2,1,'-2\-1\0\1\2',1)
        $IF(MOS2<>0) $LU=1
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(DECOMP='A')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY WITH SPARSE QR FACTORIZATION
           2 - EXACT SOLUTION BY SPARSE BUNCH-PARLETT FACTORIZATION
               OF AUGMENTED SYSTEM
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
           7 - OPTIMUM LOCALLY CONSTRAINED STEP BY QR
               FACTORIZATION
      $CHECK(NUMBER,3,'1\2\3\4\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY WITH SPARSE LU FACTORIZATION
           2 - MULTIPLE DOG-LEG STRATEGY WITH SPARSE LU
               FACTORIZATION
           3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
           4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
           5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\2\3\4\5',2,NO)
      $IF(NUMBER>2)
        $HELP
          PRECONDITIONING TECHNIQUE
            ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
            ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
            ABS(MOS2)=2 - SSOR PRECONDITIONING
               MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
               MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                          BY PRECONDITIONED ITERATIVE PROCESS
        $CHECK(MOS2,1,'-2\-1\0\1\2',1)
        $IF(MOS2<>0) $LU=1
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
    $IF(KDS=0)
      $HELP
        LINE SEARCH INTERPOLATION
          1 - BISECTION
          2 - TWO POINT QUADRATIC INTERPOLATION
          3 - THREE POINT QUADRATIC INTERPOLATION
          4 - THREE POINT CUBIC INTERPOLATION
          5 - SPECIAL BIQUADRATIC INTERPOLATION
      $CHECK(MES,3,'1\2\3\4\5',3)
      $STEP=1
      $IF(MES=5) $STEP=4
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,-2,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $ISTEP=0
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
    $KDS=0
  $ENDIF
  $IF(DECOMP='A')
    $HELP
      TYPE OF UPDATE
        B - SIMPLE SPARSE BROYDEN'S UPDATE
        V - SIMPLE VECTOR BROYDEN'S UPDATE
        R - SIMPLE RANK-ONE UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\V\R\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ELSE
    $HELP
      TYPE OF UPDATE
        B - SIMPLE SPARSE BROYDEN'S UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ENDIF
  $IF(UPDATE<>'NO')
    $IF(UPDATE='B')
      $HELP
        RESTART OF VARIABLE METRIC METHODS:
          1 - SIMPLE UPDATE
          2 - CUMMULATIVE UPDATE
      $CHECK(MET5,2,'1\2',4)
      $IF(MET5=2)
        $IF(KDS=1) $KDS=0
      $ENDIF
    $ELSEIF(UPDATE='R')
      $IF(NUMBER=3)
        $HELP
          SWITCH FOR THE HYBRID METHOD:
            0 - THE FLETCHER AND XU SWITCH WITH GENERAL UPDATE
            1 - THE FLETCHER AND XU SWITCH WITH SPECIAL UPDATE
            2 - THE DENNIS AND WELSCH SWITCH
            3 - THE RAMSIN AND WEDIN SWITCH
        $CHECK(MET3,0,'0\1\2\3',3)
      $ELSE
        $MET3=0
      $ENDIF
    $ENDIF
    $MET=1
    $ADD(INIT)
      MET=$MET
    $ENDADD
    $DEFAULT='1.0D-4'
    $IF(TYPE='L') $DEFAULT='1.0D-2'
    $HELP
      TOLERANCE FOR APPLICATION OF THE BROYDEN METHOD
    $CHECK(ETA5,DEFAULT,REAL,4)
  $ENDIF
  $IF(DECOMP='A')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
  $ENDIF
  $ISNF=0
  $ISNA=3
  $ADD(INIT)
    ISNA=3
  $ENDADD
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(UPDATE='R') $SUBST('UASET3')
  $MAL='$NA'
  $ADD(INIT)
    MAL=NA
  $ENDADD
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL3')
  $IF(NORMF>0) $SUBST('UATRL3')
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(LU=1) $SUBST('UYGISJ')
  $IF(DECOMP='A')
    $IF(NUMBER=1) $SUBST('UYSFSL')
    $IF(NUMBER=2) $SUBST('UYSFIS')
    $IF(NUMBER=7) $SUBST('UYSFSG')
  $ENDIF
*
*     ---------------------------------------------------
*     SPARSE GAUSS-NEWTON METHOD WITH THE JACOBIAN MATRIX
*     TEMPLATE : U1SSU1
*     ---------------------------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO3(-1)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
  CALL UXVSET($N,ZERO,$GO)
$L=$10 ; $LABEL
  $KD=1
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  $SUBST('UUSRD1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $MAT='G'
  $DEC=DECOMP
  $DECOMG=DEC
  $NUM=NUMBER
  $IF(DECOMP='A')
    $IF(NUMBER=2) $NUM=1
  $ENDIF
  $IF(UPDATE='R')
    $IF(MET3>0) $DEC='R'
  $ENDIF
  $IF(UPDATE='V')
    $MAT='S'
    $DECOMG='V'
  $ENDIF
  $IF(NUMBER=1) $DECOMG='A'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUM)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUM)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $IF(UPDATE='R')
    $IF(MET3=0)
      NA=NB
      MA=MB
    $ENDIF
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(NA,$AF,$AFO)
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$ 52 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$ 54 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  $IF(UPDATE='B')
    $IF(MET5=2)
    IF (FO-F.LE.ETA5*FO) KD=0
    $ENDIF
  $ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  ITERD=0
  $IF(UPDATE<>'NO')
$REM    $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(UPDATE='B')
    $SUBST('UYTR$(CONSTR)F')
    IF (FO-F.LE.ETA5*FO) THEN
    $SUBST('UUSBA1')
    ENDIF
  $ELSEIF(UPDATE='R')
    $SUBST('UYTR$(CONSTR)D')
    $IF(MET3=0)
      IF (FO-F.LE.ETA5*FO) THEN
      $SUBST('UUSBA2')
      ENDIF
    $ENDIF
  $ELSE
    $SUBST('UYTR$(CONSTR)D')
  $ENDIF
$L=$75 ; $LABEL
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(UPDATE='B')
    $IF(MET5=2) $SUBST('UYTR$(CONSTR)G')
  $ENDIF
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL3')
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1SSU1'
  $ENDADD
  $EXIT
