$INTERFACE UDGGM8                                             06/12/01
$REM MA
  $HH='HH'
  $BR='BR'
  $SR='SR'
  $IW='WN11'
  $HERF='S'
  $HELP
    PRECONDITIONING TECHNIQUE
      MOS2=1 - DIAGONAL PRECONDITIONING
      MOS2=2 - INCOMPLETE GILL-MURRAY PRECONDITIONING
      MOS2=3 - SSOR PRECONDITIONING
  $CHECK(MOS2,2,'0\1\2\3',1)
  $HELP
    DIMENSION OF THE KRYLOV SUBSPACE
  $CHECK(MOS3,10,INT,3)
  $IF(MOS3<5) $MOS3=5
  $DEFAULT=20
  $IF(MOS2=2)
    $DEFAULT=2
    $HELP
      PRECONDITIONING IN ILL-CONTITIONED AND INDEFINITE CASES
        0 - PRECONDITIONING IN BOTH THESE CASES IS SUPPRESSED
        1 - PRECONDITIONING IS ALWAYS USED
    $CHECK(MOS4,0,'0\1',1)
  $ENDIF
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,DEFAULT,INT,3)
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'1.0$P-4',REAL,4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'1.0$P-12',REAL,4)
  $HELP
    TOLERANCE FOR THE SSM METHOD
  $CHECK(ETA5,'1.0$P-4',REAL,4)
  $HELP
    TOLERANCE FOR THE COMPUTATION OF EIGENVALUES
  $CHECK(ETA6,'1.0$P-6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$GN($NF)\$SN($NF+1)\$GO($NF+1)\$GS($NF)\$XO($NF)\$XS($NF)&
  \$XP($NF)\$BR($MOS3+2)\$DR($MOS3+2)\$GR($MOS3+2)\$HR(($MOS3+2)**2)&
  \$SO($NF*($MOS3+2))\$XR($MOS3+2)\$SR($MOS3+2)\$HH($M)\$GP($NF)\XDELC')
  $ADD(REAL,'\$XM($NF)\$GM($NF)\GG($NF)')
  $IF(HERF='S')
    $ADD(REAL,'\$H($M)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$IW($NF+1)')
    $ADD(INTEGER,'\MM\NL\NLLAN\NLCOM\IT\MAXIT\ITER\MAXITER\I\TYP')
    $ADD(REAL,'\UXVDEL\UXVDOT\UXVNOR\UXSSM1\UXSSMQ\UNRAN1')
  $ENDIF
  $SET(SINIC)
    COMMON /UMFUH1/ $BR,$DR,XDELC,NLCOM
    $FLOAT UNFUH1
    EXTERNAL UNFUH1
  $ENDSET
  $ADD(REAL,'\RHO1\RHO2\NY\LAMBDA\TEMPR\EPS')
  CALL UOD1D1
  $IF(HERF='S')
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ENDIF
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UD$(HERF)GM8',1)
  GO TO $80
  ENDIF
$REM  NL=MOS3
  NLLAN=MOS3
  MM=$IH(NF)
  GNORM=SQRT(UXVDOT(NF,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='D')
    RHO1=UXDSMQ($N,$H,$GN,$GN)
  $ELSEIF(HERF='S')
    RHO1=UXSSMQ($N,MM,$H,$IH,$JH,$GN,$GN)
    NCGR=NCGR+1
  $ENDIF
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  MAXIT=1
  MAXITER=10
  NY=ZERO
  LAMBDA=ZERO
  CALL UXVNEG(NF,$GN,$GN)
  DO I=1,NF
  $GS(I)=UNRAN1(RAN)-0.5$P 0
  ENDDO
  TEMPR=UXVNOR(NF,$GS)
  CALL UXVSCL(NF,ONE/(1.0$P 2*TEMPR),$GS,$GS)
  TEMPR=UXSSM1(NF,$IH,$H,$IH(NF))
  CALL UXVSCL(NF,ONE/(XDEL*TEMPR),$GN,$GO)
  CALL UXVSUM(NF,$GS,$GO,$GO)
  CALL UXVSET(NF,ZERO,$SN)
  CALL UXVSET(NF,ZERO,$GS)
  IT=1
  TYP=1
  DO WHILE (ABS(NY-LAMBDA).LE.ETA6.AND.IT.LE.MAXIT)
*
*     $SO(NL)=LANCZOS($H,$GO,NL), MATRIX $SO(NL) HAS NL ORTHONORMAL COLUMNS
*
  CALL UXSSMT(NF,MM,$H,$IH,$JH,$GO,$SO,$DR,$SR,NLLAN,NL)
  NCGR=NCGR+NL
*
*     IF $SN<>0 AND $GS<>0 THEN $SO(NL+2):=SPAN($SN,$GS,$SO(NL))
*
  IF (IT.NE.1) THEN
  TYP=2
  CALL UXVCOP(NF,$GS,$SO(NF*NL+1))
  CALL UXVCOP(NF,$SN,$SO(NF*NL+NF+1))
  NL=NL+2
  CALL UXDCMG(NF,NL,$SO,$GO,2)
  ENDIF
*
*     ($SN,LAMBDA,$GS,$DR(1))=SSM($H,$GN,$SO)
*
  NLCOM=NL
  XDELC=XDEL
  $SUBST('UYSSMT')
  CALL UXSSMM(NF,MM,$H,$IH,$JH,$GS,$GO)
  NY=SQRT(UXVDEL(NF,-$DR(1),$GS,$GO))-$DR(1)
  IF (NY.GT.LAMBDA) LAMBDA=NY
  CALL UXSSMD(NF,MM,$H,$IH,$JH,$SN,-ONE,$GN,$XP)
  CALL UXVNEG(NF,$XP,$XP)
  CALL UXVDIR(NF,-LAMBDA,$SN,$XP,$GO)
  NCGR=NCGR+2
  IT=IT+1
  ENDDO
  ITER=1
  TEMPR=UXVNOR(NF,$GO)
  TYP=3
$REM  DO WHILE (TEMPR.GT.ETA5.AND.ITER.LE.MAXITER)
  DO WHILE (TEMPR.GT.ETA5*GNORM.AND.ITER.LE.MAXITER)
*
*     $GO=SQP($H,LAMBDA,$GN,$SN), $SO(4):=SPAN($SN,$GO,$GS,$XP),
*     CREATION OF ORTHONORMAL BASIS ($XP IS A RESIDUUM)
*
  NL=4
  CALL UXVCOP(NF,$SN,$SO(1))
  CALL UXVCOP(NF,$XP,$SO(NF+1))
  CALL UXVCOP(NF,$GS,$SO(2*NF+1))
  CALL UXVCOP(MM,$H,$HH)
  CALL UXSSDA(NF,MM,$HH,$IH,LAMBDA)
  CALL UXSSMM(NF,MM,$HH,$IH,$JH,$SN,$GG)
  CALL UXVDIR(NF,-ONE,$GG,$GN,$GG)
  NCGR=NCGR+1
  CALL UXSSCG(NF,MM,$HH,$IH,$JH,$SN,ZERO,$GG,ZERO,$GO,TEMPR,
&$XO,$XS,$XP,$GP,$XM,$GM,$IW,EPS6,ETA2,MOS2,MOS4,NDECF,NCGR,MCGR,INF)
  CALL UXVCOP(NF,$GO,$SO(3*NF+1))
  CALL UXDCMG(NF,NL,$SO,$GO,2)
*
*     ($SN,LAMBDA,$GS,$DR(1))=SSM($H,$GN,$SO)
*
  NLCOM=NL
  XDELC=XDEL
  $SUBST('UYSSMT')
  CALL UXSSMM(NF,MM,$H,$IH,$JH,$GS,$GO)
  NY=SQRT(UXVDEL(NF,-$DR(1),$GS,$GO))-$DR(1)
  CALL UXSSMD(NF,MM,$H,$IH,$JH,$SN,-ONE,$GN,$XP)
  CALL UXVNEG(NF,$XP,$XP)
  EPS=SQRT(UXVDEL(NF,-LAMBDA,$SN,$XP))
  NCGR=NCGR+2
  IF (NY.GT.LAMBDA.AND.NY+$DR(1).GT.EPS/XDEL) THEN
*
*     $GO=SQP($H,NY,0,$GS), $SO(5):=SPAN($GO,$SO(4)),
*     CREATION OF ORTHONORMAL BASIS
*
  NL=5
  CALL UXVCOP(MM,$H,$HH)
  CALL UXSSDA(NF,MM,$HH,$IH,NY)
  CALL UXSSMM(NF,MM,$HH,$IH,$JH,$GS,$GG)
  CALL UXVNEG(NF,$GG,$GG)
  NCGR=NCGR+1
  CALL UXSSCG(NF,MM,$HH,$IH,$JH,$GS,ZERO,$GG,ZERO,$GO,TEMPR,
&$XO,$XS,$XP,$GP,$XM,$GM,$IW,EPS6,ETA2,MOS2,MOS4,NDECF,NCGR,MCGR,INF)
  CALL UXVCOP(NF,$GO,$SO(4*NF+1))
  CALL UXDCMG(NF,NL,$SO,$GO,2)
*
*     ($SN,LAMBDA,$GS,$DR(1))=SSM($H,$GN,$SO)
*
  NLCOM=NL
  XDELC=XDEL
  $SUBST('UYSSMT')
  CALL UXSSMM(NF,MM,$H,$IH,$JH,$GS,$GO)
  NY=SQRT(UXVDEL(NF,-$DR(1),$GS,$GO))-$DR(1)
  IF (NY.GT.LAMBDA) LAMBDA=NY
  CALL UXSSMD(NF,MM,$HF,$IH,$JH,$SN,-ONE,$GN,$XP)
  CALL UXVNEG(NF,$XP,$XP)
  TEMPR=SQRT(UXVDEL(NF,-LAMBDA,$SN,$XP))
  NCGR=NCGR+2
  GOTO $99
  ENDIF
  IF (NY.GT.LAMBDA) THEN
  LAMBDA=NY
  TEMPR=SQRT(UXVDEL(NF,-LAMBDA,$SN,$XP))
  ELSE
  TEMPR=EPS
  ENDIF
$99 ITER=ITER+1
  ENDDO
  SNORM=UXVNOR(NF,$SN)
  CALL UXVNEG(NF,$GN,$GN)
$80 CONTINUE
  $IF(HERF='S')
    PP=UXSSMQ($N,M,$H,$IH,$JH,$SN,$SN)*HALF
    NCGR=NCGR+1
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(HERF)GM8'
  $ENDADD
*
  $ADD(SUBROUTINES)
* SUBROUTINE UYSSMT                ALL SYSTEMS                07/12/01
* PORTABILITY : ALL SYSTEMS
* 06/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  1, THIS SUBROUTINE SOLVES A QUADRATIC PROGRAMMING PROBLEM:
*       MIN  TRANS(X)*H*X + 2*TRANS(G)*X  S.T.  ||X||=R,  X IN S(K),
*     BY REDUCING IT WITH ORTHONORMAL MATRIX V TO THE PROBLEM
*       MIN  TRANS(Y)*(TRANS(V)*H*V)*Y + 2*(TRANS(G)*V)*Y  S.T.  ||Y||=R.
*  2, ESTIMATE FOR THE SMALLEST EIGENVALUE OF H AND ASSOCIATED EIGENVECTOR.
*
* PARAMETERS :
*  II  N  ORDER OF THE SPARSE SYMMETRIC MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  II  NL  DIMENSION OF SUBSPACE S(K).
*  RI  H(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IH(N+1) POINTERS OF THE HESSIAN MATRIX STORED IN A COMPACT FORM.
*  II  JH(M) COLUMN INDICES OF NONZEROES IN THE MATRIX A.
*  RI  G(N)  GRADIENT.
*  RO  S(N)SOLUTION OF THE SUBPROBLEM.
*  RI  V(N*NL)  ORTHONORMAL BASIS FOR SUBSPACE S(K).
*  RA  E(NL)  SUBDIAG. ELEMENTS OF TRIDIAGONAL DECOMPOSITION TRANS(V)*H*V.
*  RA  Q(NL*NL)  ESTIMATED EIGENVECTORS OF REDUCED MATRIX T=TRANS(V)*H*V.
*  RA  C(NL)  AUXILIARY VECTOR.
*  RA  Y(NL)  SOLUTION OF THE REDUCED PROBLEM WITH MATRIX T.
*  RO  W(N)  EIGENVECTOR ASS. WITH THE ESTIMATED SMALLEST EIGENVALUE OF H.
*  RO  LAMBDA  LAGRANGE MULTIPIER ASSOCIATED WITH THE ORIGINAL SOLUTION.
*  RI  ETA6 TOLERANCE FOR ZERO.
*  II  JOB  SPECIFIES WHAT HAVE TO BE DONE WITH MATRIX H:
*        JOB = 1 - TRIDIAGONAL DECOMPOSITION T=TRANS(V)*H*V IS ALREADY DONE
*                  FROM THE LANCZOS PROCESS, SO WE DO ONLY ITS EIGENDECOMP.
*        JOB = 2 - WE HAVE TO MAKE A MATRIX T=TRANS(V)*H*V OF ORDER NL, THAT
*                  CONTAINS A TRIDIAGONAL BLOCK OF ORDER NL. THEN WE DO ITS
*                  EIGENDECOMPOSITION.
*        JOB = 3 - WE HAVE TO MAKE A FULL MATRIX T=TRANS(V)*H*V OF ORDER FOUR
*                  OR FIVE AND THEN DO ITS EIGENDECOMPOSITION.
*
* COMMON DATA :
*  RU  DR(NL+2)  DIAGONAL ELEMENTS OF TRIDIAG. DECOMPOSITION TRANS(V)*H*V.
*                ON OUTPUT ESTIMATED EIGENVALUES OF THE MATRIX H.
*  RA  BR(NL+2)  AUXILIARY ARRAY.
*  RI  XDELC  TRUST REGION RADIUS.
*  IA  NLCOM  EQUAL TO NL.
*
* METHOD :
*  W.W.HAGER: MINIMIZING A QUADRATIC OVER A SPHERE,
*  SIAM J. OPTIM., 12(1): 188-208, 2001.
*
* SUBPROGRAMS USED :
*  S   UXDRMM  MULTIPLICATION OF A ROWWISE STORED DENSE RECTANGULAR MATRIX BY
*              A VECTOR.
*  S   UXDCMM  MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX
*              BY A VECTOR.
*  S   UXSSMM  MULTIPLICATION OF A SPARSE SYMMETRIC MATRIX BY A VECTOR.
*  S   UXTQIP  COMPUTATION OF THE EIGENPAIRS OF A SYMMETRIC TRIDIAGONAL MATRIX.
*  S   UXDSTP  REDUCTION OF A REAL SYMMETRIC MATRIX TO A SYMM. TRIDIAG. MATRIX.
*  S   UXTQEP  COMPUTATION OF THE EIGENPAIRS OF A SYMMETRIC TRIDIAGONAL MATRIX.
*  S   UNNEQ1  SOLUTION OF A SINGLE NONLINEAR EQUATION.
*  S   UOERR1  PREPARATION OF ERROR PRINT.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  RF  UXVNOR  EUCLIDEAN NORM OF A VECTOR.
*  RF  UNFUH1  EXTERNAL FUNCTION.
*
      SUBROUTINE UYSSMT(N,M,NL,H,IH,JH,G,S,V,E,Q,C,Y,W,LAMBDA,ETA6,JOB)
      $INCLUDE('UMCOMM')
      INTEGER N,NL,M,IH(N+1),JH(M),JOB
      $FLOAT H(M),G(N),S(N),V(N*NL),E(NL),Q(NL*NL),C(NL),Y(NL),W(N),
     & LAMBDA,ETA6,CON1,CON2
      INTEGER IER,OPT,I,J,TEMPJ,NNIT,NNITER,NLCOM
      $FLOAT LAMBDAL,LAMBDAU,SUM,CNORM,TEMPR,UXVDOT,UXVNOR
      $FLOAT $BR($MOS3+2),$DR($MOS3+2),XDELC
      COMMON /UMFUH1/ $BR,$DR,XDELC,NLCOM
      PARAMETER (CON1=1.0$P-6,CON2=1.0$P-6)
      $FLOAT UNFUH1
      EXTERNAL UNFUH1
      NNIT=50
      CALL UXDRMM(N,NL,V,G,C)
      CNORM=UXVNOR(NL,C)
      IF (JOB.EQ.1) THEN
*
*     DECOMPOSITION T=TRANS(V)*H*V IS ALREADY MADE FROM THE LANCZOS PROCESS
*
      DO I=1,NL
      DO J=1,NL
      Q((I-1)*NL+J)=ZERO
      ENDDO
      Q((I-1)*NL+I)=ONE
      ENDDO
*
*     EIGENDECOMPOSITION T=Q*D*TRANS(Q)
*
      CALL UXTQIP(NL,$DR,E,Q,IER)
      IF (IER.NE.0) THEN
      ITERM=-107
      CALL UOERR1('UXTQIP',107)
      RETURN
      ENDIF
      ELSE IF (JOB.EQ.2) THEN
*
*     MULTIPLICATION T=TRANS(V)*H*V: TRIDIAGONAL BLOCK OF ORDER NL OCCURS,
*     HERE T=Q IS OF ORDER NL+2
*
      CALL UXSSMM(N,M,H,IH,JH,V(1),W)
      Q(1)=UXVDOT(N,W,V(1))
      DO J=2,NL
      Q((J-1)*NL+1)=ZERO
      ENDDO
      Q(2)=UXVDOT(N,W,V(N+1))
       CALL UXSSMM(N,M,H,IH,JH,V(N+1),W)
       Q(NL+2)=UXVDOT(N,W,V(N+1))
      DO J=3,NL
      Q((J-1)*NL+2)=ZERO
      ENDDO
      DO I=3,NL-1
      DO J=1,I-2
      Q((J-1)*NL+I)=ZERO
      ENDDO
      Q((I-2)*NL+I)=UXVDOT(N,W,V((I-1)*N+1))
       CALL UXSSMM(N,M,H,IH,JH,V((I-1)*N+1),W)
      Q((I-1)*NL+I)=UXVDOT(N,W,V((I-1)*N+1))
      DO J=I+1,NL
      Q((J-1)*NL+I)=ZERO
      ENDDO
      ENDDO
      DO J=1,NL-3
      Q(J*NL)=ZERO
      ENDDO
       CALL UXSSMM(N,M,H,IH,JH,V((NL-1)*N+1),W)
      DO J=NL-2,NL
      Q(J*NL)=UXVDOT(N,W,V((J-1)*N+1))
      ENDDO
      NCGR=NCGR+NL
*
*     EIGENDECOMPOSITION Q*D*TRANS(Q)
*
      CALL UXDSTP(NL,Q,$DR,E)
      CALL UXTQEP(NL,$DR,E,Q,IER)
      IF (IER.NE.0) THEN
      ITERM=-107
      CALL UOERR1('UXTQEP',107)
      RETURN
      ENDIF
      ELSE IF (JOB.EQ.3) THEN
*
*     MULTIPLICATION TRANS(V)*H*V: FULL MATRIX OF ORDER FOUR OR FIVE
*
      DO I=1,NL
      CALL UXSSMM(N,M,H,IH,JH,V((I-1)*N+1),W)
      DO J=1,I
      Q((J-1)*NL+I)=UXVDOT(N,W,V((J-1)*N+1))
      ENDDO
      DO J=I+1,NL
      Q((J-1)*NL+I)=ZERO
      ENDDO
      ENDDO
      NCGR=NCGR+NL
*
*     EIGENDECOMPOSITION Q*D*TRANS(Q)
*
      CALL UXDSTP(NL,Q,$DR,E)
      CALL UXTQEP(NL,$DR,E,Q,IER)
      IF (IER.NE.0) THEN
      ITERM=-107
      CALL UOERR1('UXTQEP',107)
      RETURN
      ENDIF
      ENDIF
*
*     HAGER: USE OF LEMMA 2 (DETERMINATION OF THE CASE)
*
      DO I=1,NL
      $BR(I)=UXVDOT(NL,C,Q((I-1)*NL+1))
      ENDDO
      OPT=0
      IF ($DR(1).GT.ETA6) THEN
      SUM=ZERO
      DO I=1,NL
      SUM=SUM+$BR(I)**2/$DR(I)**2
      ENDDO
      IF (SUM.LE.XDELC**2) OPT=1
      ENDIF
      IF (DABS($DR(1)).LE.ETA6) THEN
      J=0
      DO I=1,NL
      IF (DABS($DR(I)).LE.ETA6) THEN
      J=J+1
      IF (DABS($BR(I)).LE.ETA6) J=J-1
      ENDIF
      ENDDO
      IF (J.EQ.0) THEN
      SUM=ZERO
      DO I=1,NL
      IF ($DR(I).GT.ETA6) SUM=SUM+$BR(I)**2/$DR(I)**2
      ENDDO
      IF (SUM.LE.XDELC**2) OPT=1
      ENDIF
      ENDIF
      IF ($DR(1).LT.-ETA6) THEN
      J=0
      DO I=1,NL
      IF ($DR(I)-$DR(1).LE.ETA6) THEN
      J=J+1
      IF (DABS($BR(I)).LE.ETA6) J=J-1
      ENDIF
      ENDDO
      IF (J.EQ.0) THEN
      SUM=ZERO
      TEMPJ=0
      DO I=1,NL
      IF ($DR(I)-$DR(1).GT.ETA6) THEN
      SUM=SUM+$BR(I)**2/($DR(I)-$DR(1))**2
      ELSE
      TEMPJ=TEMPJ+1
      ENDIF
      ENDDO
      IF (SUM.LE.XDELC**2) THEN
      TEMPR=SUM
      OPT=2
      ENDIF
      ENDIF
      ENDIF
*
*     HAGER: USE OF LEMMA 2 (COMPUTATION OF COEFFICIENTS C)
*
      IF (OPT.EQ.1) THEN
      DO I=1,NL
      IF ($DR(I).GT.ETA6) C(I)=$BR(I)/$DR(I)
      IF ($DR(I).LE.ETA6) C(I)=ZERO
      ENDDO
      LAMBDA=ZERO
      ELSEIF (OPT.EQ.2) THEN
      TEMPR=SQRT((XDELC**2-TEMPR)/TEMPJ)
      DO I=1,NL
      IF ($DR(I)-$DR(1).GT.ETA6) THEN
      C(I)=$BR(I)/($DR(I)-$DR(1))
      ELSE
      C(I)=TEMPR
      ENDIF
      ENDDO
      LAMBDA=-$DR(1)
      ELSE
      LAMBDAU=CNORM/XDELC-$DR(1)
      SUM=ZERO
      DO I=1,NL
      IF ($DR(I)-$DR(1).LE.ETA6) SUM=SUM+$BR(I)**2
      ENDDO
      LAMBDAL=SQRT(SUM)/XDELC-$DR(1)
      NNITER=NNIT
      CALL UNNEQ1(LAMBDAL,LAMBDAU,LAMBDA,TEMPR,UNFUH1,CON1,CON2,
     &    NNITER,IER)
      DO I=1,NL
      C(I)=$BR(I)/($DR(I)+LAMBDA)
      ENDDO
      ENDIF
*
*     SOLUTION: Y=SUM(C_I*Q_I), S=V*Y, W=V*Q_1
*
      CALL UXDCMM(NL,NL,Q,C,Y)
      CALL UXDCMM(N,NL,V,Y,S)
      CALL UXDCMM(N,NL,V,Q,W)
      RETURN
      END
      FUNCTION UNFUH1(LAMBDA)
      $FLOAT UNFUH1,LAMBDA
      INTEGER NLCOM
      $FLOAT $BR($MOS3+2),$DR($MOS3+2),XDELC
      COMMON /UMFUH1/ $BR,$DR,XDELC,NLCOM
      INTEGER I
      UNFUH1=0.0$P 0
      DO I=1,NLCOM
      UNFUH1=UNFUH1+$BR(I)**2/($DR(I)+LAMBDA)**2
      ENDDO
      UNFUH1=UNFUH1-XDELC**2
      RETURN
      END
  $ENDADD
  $EXIT
