$INTERFACE UDSGI3                                             03/12/01
$REM LU
  $NN='NC'
  $D='D'
  $XS='XS'
  $GS='GS'
  $XP='XP'
  $CON1='1.0$P-3'
  $CON3='0.8$P 0'
  $CON4='0.2$P 0'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      1 - CONSTANT PENALTY PARAMETER
      2 - PENALTY PARAMETER IS DETERMINED FROM THE QUADRATIC MODEL
  $CHECK(MOS1,1,'1\2',4)
  $MOS2=1
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
               EQUATION APPROACH.
    MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
    MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
  $CHECK(MOS2,1,'-1\1',3)
  $NOS2=MOS2
  $IF(NOS2=-1) $NOS2=1
  $HELP
    DECISION AFTER NEGATIVE CURVATURE IS FOUND
      1 - INDEFINITE ITERATIONS
      2 - DETERMINATION OF THE BOUNDARY STEP
  $CHECK(MOS3,1,'1\2',4)
  $HELP
    NORM IN THE DEFINITION OF THE TRUST REGION
      0 - TRUST REGION IS DEFINED BY SLACK VARIABLES
      1 - TRUST REGION IS DEFINED BY THE INFINITY NORM
      2 - TRUST REGION IS DEFINED BY THE SPECTRAL NORM
  $CHECK(MOS4,2,'0\1\2',4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $DEFAULT='0.9$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-1',REAL,4)
  $DEFAULT='1.0D-6'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $HELP
    UPPER BOUND FOR LAGRANGIAN FUNCTION
  $CHECK(TOLU,'1.0$P 30',REAL,4,NO)
  $ORDER=1
  $ADD(REAL,'\$CG($MC)\$CF($NC+1)\$GC($NF)\$G($NF)&
  \$S($NF+$NCA)\$XO($NF+$NCA)\$GO($NF+$NCA)\$XS($NF+$NCA)&
  \$GS($NF+$NCA)\$D($NF+$NCA)\$CP($NCA)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)\$IX($NX)\$IC($NC)\$ICA($NCA)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT\UCIDOS')
  $ADD(REAL,'\ALF\DEL\RHO\RHO1\RHO2\SIG')
  $ADD(INTEGER,'\I\L\MM\MMX\NCA\IPOM\KPOM\NOS\IFILL')
  $ADD(REAL,'\$B($MMAX)')
  $ADD(INTEGER,'\$IB($NCA+1)\$JB($MMAX)\$PSR($NCA+1)&
  \$PERC($NCA)\$INVP($NCA)\$WN11($NCA+1)\$WN12($NCA+1)&
  \$WN13($NCA+1)\$WN14($NCA+1)')
  $ADD(INTEGER,'\MS')
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='S')
    M=$IH(NF+1)-1
  $ELSEIF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ENDIF
  IPOM=0
  CALL UXVNEG(NF,$G,$XS)
*
*     DETERMINATION OF ACTIVE CONSTRAINTS AND CONSTRUCTION OF THE
*     CORRESPONDING KARUSH-KUHN-TUCKER SYSTEM
*
  CALL UCIACT(NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC&
,$CSL,$CSU,$CZL,$CZU,$ICA,EPS9,INF)
  $IF(HERF='S')
    CALL UCINAT(NF,NX,NC,MC,M,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$ICG,$JCG,$XS,$GO,$H,$IH,$JH,RPF3&
,MEP1)
  $ELSE
    CALL UCINAD(NF,NX,NC,MC,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$ICG,$JCG,$XS,RPF3,MEP1)
  $ENDIF
  CALL UCISLC(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S(NF+1),$XS(NF+1),$D(NF+1),RPF3,MEP1)
  CALL UODLI3(NF,NX,NC,NCA,$IX,$IC,$ICA,$XS,RPF2,RPF3,INF)
  MM=NF+NCA
  $IF(MOS4=2)
    GNORM=SQRT(UX$(POM1)DOT(NF,$G,$G$POM2+UCIDOS(NX,NC,NCA,$IX,$IC&
,$ICA,$XS(NF+1),$XS(NF+1)))
  $ELSE
    $ADD(REAL,'\BET\UCIMAS')
    GNORM=MAX(UX$(POM1)MAX(NF,$G$POM2,UCIMAS(NX,NC,NCA,$IX,$IC,$ICA&
,$XS(NF+1)))
  $ENDIF
  IF (GNORM.GT.$TOLU) THEN
  CALL UOERR1('UDSGI3',101)
  ITERM=-101
  TDXX='LARGE LF'
  GO TO $90
  ENDIF
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  XDEL=GNORM
  IF (IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/SQRT(UX$(POM1)DOT(NF,$G&
,$G$POM2))
  XDEL=MIN(XDEL,XMAX)
  IF (XDEL.LE.ZERO) XDEL=XMAX
  ENDIF
*
*     CONSTRUCTION OF THE NORMAL MATRIX OF ACTIVE CONSTRAINTS
*
  NOS=$NOS2
  IF (IDECF.LT.0) IDECF=0
  IF (IDECC.LT.0) IDECC=0
  DO $20 I=1,NF
  $IF(KBF>0)
    IF (IX(I).EQ.-5) THEN
    $D(I)=ZERO
    ELSE
    $D(I)=ONE
    ENDIF
  $ELSE
    $D(I)=ONE
  $ENDIF
$20 CONTINUE
  IF (NCA.GT.0.AND.INF.GT.0) THEN
  $SUBST('UCISS1')
  IF (ITERM.NE.0) THEN
  TDXX='DENSE R '
  GO TO $90
  ENDIF
  MS=0
  L=$IB(NCA+1)-1
  CALL UXSPCC(NCA,L,MS,$MMAX,$B,$IB,$JB,$PSR,$PERC&
,$INVP,$WN11,$WN12,$WN13,$WN14,$ORDER,IFILL,ITERM)
  IF (ITERM.LT.0) THEN
  TXFU='LACK SPC'
  ENDIF
  ENDIF
  IF (NCA.LE.0) THEN
  L=0
  NOS=0
  ELSE
  $SUBST('UCINS1')
  IF (L.GE.$MMAX) THEN
  CALL UOERR2('UDSGI3',49,L,$MMAX)
  ITERM=-49
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
  CALL UXSSMM(NCA,$IB(NCA+1)-1,$B,$IB,$JB,$S(NF+1),$GS(NF+1))
*
*     CONSTRUCTION OF THE CG PRECONDITIONER
*
  ALF=ETA2
  CALL UXSPCT(NCA,L,MS,MMAX,$B,$JB,$PSR,ITERM)
  IF (ITERM.NE.0) THEN
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
  CALL UXSPCF(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$WN11,$WN12,$GO,INF&
,ALF,SIG)
  $IF(MD>0)
    IF (ND.GT.0) THEN
    CALL UXSPCX(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$GO(NF+1))
    ENDIF
  $ENDIF
  NDECC=NDECC+1
  ENDIF
  DO $30 I=1,NCA
  $D(NF+I)=SQRT(ABS($D(NF+I)))
$30 CONTINUE
*
*     RANGE SPACE (VERTICAL) DIRECTION USING THE DOG-LEG STRATEGY
*
  DEL=$CON3*XDEL
  RHO1=UXVDOT(NCA,$S(NF+1),$GS(NF+1))
  RHO2=UXVDOT(NCA,$GS(NF+1),$GS(NF+1))
  IF (RHO1.LE.ZERO.OR.RHO2.LE.ZERO) THEN
  ALF=ZERO
  CALL UXVSET(NF,ZERO,$S)
  CALL UXVSET(NCA,ZERO,$GS(NF+1))
  SNORM=ZERO
  TDXX='DOG ZERO'
  ELSE
  $IF(MOS4=2)
    SNORM=RHO1**(THREE/TWO)/RHO2
    IF (SNORM.GE.DEL) THEN
    ALF=DEL/SQRT(RHO1)
    CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),$S)
    CALL UXVMUL(NCA,$D(NF+1),$S(NF+1),$GS(NF+1),1)
    CALL UXVSCL(NF,ALF,$S,$S)
    CALL UXVSCL(NCA,ALF,$GS(NF+1),$GS(NF+1))
    SNORM=DEL
    TDXX='DOG CP-2'
    ELSE
    CALL UXVCOP(NCA,$S(NF+1),$GS(NF+1))
    $IF(MD>0)
      CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$GS(NF+1),$CP)
    $ELSE
      CALL UXVSFP(NCA,$PERC,$GS(NF+1),$GO)
      CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$GS(NF+1),0)
      CALL UXVSBP(NCA,$PERC,$GS(NF+1),$GO)
    $ENDIF
    RHO=SNORM
    SNORM=SQRT(UXVDOT(NCA,$S(NF+1),GS(NF+1)))
    IF (SNORM.LE.DEL) THEN
    ALF=ONE
    CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GS(NF+1),$S)
    CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
    TDXX='DOG NP-2'
    ELSE
    SIG=SNORM
    SNORM=RHO
    RHO=(RHO1/RHO2)*UXVDOT(NCA,$S(NF+1),$S(NF+1))
    CALL UXVSCL(NCA,RHO1/RHO2,$S(NF+1),$S(NF+1))
    CALL UXVDIF(NCA,$GS(NF+1),$S(NF+1),$GS(NF+1))
    RHO1=RHO-SNORM**2
    RHO2=SIG**2-RHO-RHO1
    CALL UNSTEP(DEL,SNORM,RHO1,RHO2,ALF)
    CALL UXVDIR(NCA,ALF,$GS(NF+1),$S(NF+1),$GS(NF+1))
    SNORM=DEL
    CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GS(NF+1),$S)
    CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
    TDXX='DOG ST-2'
    ENDIF
    ENDIF
  $ELSE
    CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),$S)
    CALL UXVMUL(NCA,$D(NF+1),$S(NF+1),$GS(NF+1),1)
    CALL UXVSCL(NF,RHO1/RHO2,$S,$S)
    CALL UXVSCL(NCA,RHO1/RHO2,$GS(NF+1),$GS(NF+1))
    ALF=ONE
    CALL UX$(POM1)TRS(NF,DEL,$S,$S,ALF,0$POM2
    CALL UCITRS(NX,NC,NCA,$IX,$XSL,$XSU,$IC,$CSL,$CSU,$ICA,$D(NF+1)&
,DEL,$GS(NF+1),$GS(NF+1),ALF,0,MOS4,INF)
    IF (ALF.LT.ONE) THEN
    CALL UXVSCL(NF,ALF,$S,$S)
    CALL UXVSCL(NCA,ALF,$GS(NF+1),$GS(NF+1))
    TDXX='DOG CP-1'
    IF (INF.NE.0) TDXX='DOG CP-0'
    ELSE
    $IF(MD>0)
      CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
    $ELSE
      CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
      CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
      CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
    $ENDIF
    CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),$GS)
    CALL UXVMUL(NCA,$D(NF+1),$S(NF+1),$S(NF+1),1)
    ALF=ONE
    CALL UX$(POM1)TRS(NF,DEL,$GS,$GS,ALF,0$POM2
    CALL UCITRS(NX,NC,NCA,$IX,$XSL,$XSU,$IC,$CSL,$CSU,$ICA,$D(NF+1)&
,DEL,$S(NF+1),$S(NF+1),ALF,0,MOS4,INF)
    IF (ALF.LT.ONE) THEN
    ALF=ONE
    CALL UX$(POM1)TRS(NF,DEL,$S,$GS,ALF,-1$POM2
    CALL UCITRS(NX,NC,NCA,$IX,$XSL,$XSU,$IC,$CSL,$CSU,$ICA,$D(NF+1)&
,DEL,$GS(NF+1),$S(NF+1),ALF,-1,MOS4,INF)
    CALL UXVDDR(NF,$S,ALF,$GS,$S,$S)
    CALL UXVDDR(NCA,$GS(NF+1),ALF,$S(NF+1),$GS(NF+1),$GS(NF+1))
    TDXX='DOG ST-1'
    IF (INF.NE.0) TDXX='DOG ST-0'
    ELSE
    CALL UX$(POM1)COP(NF,GS,S$POM2
    CALL UXVCOP(NCA,S(NF+1),GS(NF+1))
    TDXX='DOG NP-1'
    IF (INF.NE.0) TDXX='DOG NP-0'
    ENDIF
    ENDIF
    SNORM=MAX(UX$(POM1)MAX(NF,$S$POM2,UCIMAS(NX,NC,NCA,$IX,$IC,$ICA&
,$GS(NF+1)))
  $ENDIF
  ENDIF
  CALL UOD0D3(ALF,SNORM,DEL)
*
*     NULL SPACE (HORIZONTAL) DIRECTION USING THE CG METHOD
*
*
*     CG INITIATION
*
  $IF(HERF='D')
    CALL UXDSMD(NF,$H,$S,-ONE,$XS,$GO)
    CALL UCISMM(NF,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$S,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ELSEIF(HERF='S')
    CALL UXSSMD(NF,M,$H,$IH,$JH,$S,-ONE,$XS,$GO)
  $ELSEIF(HERF='L')
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$S,$GO,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$S,$GO,PAR3,MET1)
    $ENDIF
    CALL UXVDIF($N,$GO,$XS,$GO)
    CALL UCISMM(NF,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$S,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ENDIF
  CALL UXVDIF(NCA,$GS(NF+1),$XS(NF+1),$GO(NF+1))
  CALL UXVNEG(MM,$GO,$XS)
*
*     CG PRECONDITIONING
*
  CALL UXVMUL(NCA,$D(NF+1),$GO(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GO,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
  CALL UCICMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),ONE,$XS,$GO)
  CALL UXVMUD(NCA,$D(NF+1),$S(NF+1),ONE,$XS(NF+1),$GO(NF+1),1)
  CALL UXVNEG(NCA,$S(NF+1),$S(NF+1))
  CALL UXVCOP(MM,$GO,$XO)
  RHO1=UX$(POM1)DOT(NF,$GO,$XS$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GO(NF+1),$XS(NF+1))
  RHO=RHO1
  PAR=MIN(EPS6,SQRT(RHO1))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE(NF-NCA)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  KPOM=0
  MMX=MM+3
  IF(MCGR.GT.0) MMX=MIN(MMX,MCGR)
*
*     CG ITERATIONS
*
  DO $50 NRED=1,MMX
  $IF(HERF='D')
    CALL UXDSMM(NF,$H,$XO,$GO)
    CALL UCISMM(NF,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$XO,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ELSEIF(HERF='S')
    CALL UXSSMM(NF,M,$H,$IH,$JH,$XO,$GO)
  $ELSEIF(HERF='L')
    CALL UXLSMM(NF,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XO,$GO,PAR3&
,$MET)
    CALL UCISMM(NF,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$XO,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ENDIF
  CALL UXVCOP(NCA,$XO(NF+1),$GO(NF+1))
  ALF=UX$(POM1)DOT(NF,$XO,$GO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$XO(NF+1),$GO(NF+1))
  $IF(MOS3=1)
    IF (ALF.EQ.ZERO) THEN
    ITERD=-5
    TDXX='CG BREAK'
    CALL UOERR1('UDSGI3',5)
    GO TO $90
    ENDIF
  $ELSEIF(MOS3=2)
    IF (ALF.LE.ZERO) THEN
    $IF(MOS4=2)
      TDXX='CG MAX-2'
      GO TO $70
    $ELSE
      ALF=ETA9
      CALL UX$(POM1)TRS(NF,XDEL,$S,$XO,ALF,1$POM2
      CALL UCITRS(NX,NC,NCA,$IX,$XSL,$XSU,$IC,$CSL,$CSU,$ICA,$D(NF+1)&
,XDEL,$GS(NF+1),$XO(NF+1),ALF,1,MOS4,INF)
      CALL UX$(POM1)DIR(NF,ALF,$XO,$S,$S$POM2
      CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$GS(NF+1))
      TDXX='CG MAX-1'
      IF (INF.NE.0) TDXX='CG MAX-0'
      GO TO $70
    $ENDIF
    ENDIF
  $ENDIF
  ALF=RHO/ALF
  $IF(MOS4=2)
    CALL UX$(POM1)DIR(NF,ALF,$XO,$S,$GS$POM2
    CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$S(NF+1))
    RHO2=SQRT(UX$(POM1)DOT(NF,$GS,$GS$POM2+UCIDOS(NX,NC,NCA,$IX,$IC&
,$ICA,$S(NF+1),$S(NF+1)))
    IF (RHO2.GE.XDEL) THEN
    TDXX='CG MAX+2'
    GO TO $70
    ELSE
    CALL UX$(POM1)COP(NF,$GS,$S$POM2
    CALL UXVCOP(NCA,$S(NF+1),$GS(NF+1))
    SNORM=RHO2
    ENDIF
  $ELSE
    BET=ALF
    CALL UX$(POM1)TRS(NF,XDEL,$S,$XO,ALF,1$POM2
    CALL UCITRS(NX,NC,NCA,$IX,$XSL,$XSU,$IC,$CSL,$CSU,$ICA,$D(NF+1)&
,XDEL,$GS(NF+1),$XO(NF+1),ALF,1,MOS4,INF)
    CALL UX$(POM1)DIR(NF,ALF,$XO,$S,$S$POM2
    CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$GS(NF+1))
    IF (ALF.LT.BET) THEN
    TDXX='CG MAX+1'
    IF (INF.NE.0) TDXX='CG MAX+0'
    GO TO $70
    ELSE
    SNORM=MAX(UX$(POM1)MAX(NF,$S$POM2,UCIMAS(NX,NC,NCA,$IX,$IC,$ICA&
,$GS(NF+1)))
    ENDIF
  $ENDIF
*
*     CG STEP
*
  CALL UX$(POM1)DIR(NF,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO(NF+1),$XS(NF+1),$XS(NF+1))
  CALL UXVNEG(MM,$XS,$GO)
*
*     CG PRECONDITIONING
*
  CALL UXVMUL(NCA,$D(NF+1),$GO(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GO,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
  CALL UCICMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),ONE,$XS,$GO)
  CALL UXVMUD(NCA,$D(NF+1),$S(NF+1),ONE,$XS(NF+1),$GO(NF+1),1)
  CALL UXVNEG(NCA,$S(NF+1),$S(NF+1))
  RHO2=UX$(POM1)DOT(NF,$GO,$XS$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GO(NF+1),$XS(NF+1))
  IF (RHO2.LE.PAR*RHO1) GO TO $60
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR(NF,ALF,$XO,$GO,$XO$POM2
  CALL UXVDIR(NCA,ALF,$XO(NF+1),$GO(NF+1),$XO(NF+1))
  RHO=RHO2
$50 CONTINUE
  TDXX='MAX ITER'
$60 CONTINUE
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  ITERD=2
  TDXX='CG STEP '
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$70 CONTINUE
  $IF(MOS4=2)
    RHO1=UX$(POM1)DOT(NF,$S,$XO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GS(NF+1),$XO(NF+1))
    RHO2=UX$(POM1)DOT(NF,$XO,$XO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$XO(NF+1),$XO(NF+1))
    CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
    CALL UX$(POM1)DIR(NF,ALF,$XO,$S,$S$POM2
    CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$GS(NF+1))
  $ENDIF
  SNORM=XDEL
  NRED=-NRED
  ITERD=3
  CALL UOD0D3(ALF,SNORM,XDEL)
  CALL UX$(POM1)DIR(NF,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO(NF+1),$XS(NF+1),$XS(NF+1))
  CALL UXVMUL(NCA,$D(NF+1),$XS(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XS,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
  CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
  CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
  CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
$80 CONTINUE
  CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
  $SUBST('UDSGID')
$90 CONTINUE
  R=ZERO
  CALL UXVSET(NX,ZERO,XO)
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSGI3'
  $ENDADD
  $EXIT
