$INTERFACE UDSLI1                                             03/12/01
$REM LU
  $D='D'
  $GS='GS'
  $KX='KX'
  $KB='KB'
  $IW='IW'
  $IW1='IW1'
  $IW2='IW2'
  $KCG='KCG'
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON3='0.0$P 0'
  $CON4='1.0$P-1'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
$REM  $CON7='1.0$P-12'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $POM1='V'
$REM  $POM2=')'
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$H($M)\$CG($MC)\$B($MMAX)\$CF($NC+1)\$CFD($NC+1)&
  \$G($NF)\$S($NF+$NCA)\$XO($NF+$NCA)\$GO($NF+$NCA)\$GS($NF+$NCA)&
  \$D($NF+$NCA)\$B($M+$MC+$NC+2*$NX)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)&
  \$KCG($MC)\$KX($NX)\$ICA($NC+$NX)\$IB($NF+$NC+$NX+1)&
  \$JB($M+$MC+$NC+2*$NX)\$KB($M+$MC+$NC+$NX)\$IW($MMAX)&
  \$IW1(2*($NF+$NC+$NX))\$IW2(3*($NF+$NC+$NX))\$IX($NX)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\STOL\SIG1\ALF')
  $ADD(INTEGER,'\I\J\MM\NN\NCA\IPOM\KPOM')
  $MOT1=0
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $DEFAULT='ETA0*1.0D-3'
$REM  $IF(MEP=3) $DEFAULT='1.0$P-4'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  CALL UOD1D1
  $GRAD=G
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  CALL UXVNEG($N,$G,$GS)
*
*     DETERMINATION OF ACTIVE CONSTRAINTS AND CONSTRUCTION OF THE
*     CORRESPONDING KARUSH-KUHN-TUCKER SYSTEM
*
  M=$IH($N+1)-1
  IF (NIT.LE.LIT+1) NCA=-1
  STOL=$CON3*(GMAX+CMAX)
  IF (KIT.GE.NIT) STOL=ZERO
  CALL UCIACT(NX,$NN,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC,$CSL,$CSU,$CZL&
,$CZU,$ICA,EPS9,INF)
  CALL UCINAT($N,NX,$NN,MC,M,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$ICG,$JCG,$GS,$GO,$H,$IH,$JH,RPF3&
,MEP1)
  CALL UCISEC($N,NX,$NN,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$GS($N+1),$D($N+1),STOL,RPF3,SIG1&
,MOT1,MEP1)
  CALL UODLI3($N,NX,$NN,NCA,$IX,$IC,$ICA,$GS,RPF2,RPF3,INF)
  IF (INF.GT.0) THEN
  CALL UXSLIS($N,M,$IH,$JH,NX,$NN,MC,$ICG,$JCG,$KCG,$KX,NCA,$ICA,$IB&
,$JB)
  NN=$N+NCA
  MM=IB(NN+1)-1
  IF (MM.GE.$MMAX) THEN
  CALL UOERR2('UD$(HERF)LI$(NUMBER)',49,MM,$MMAX)
  ITERM=-49
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
  DO $20 I=1,NN
  DO $10 J=IB(I),IB(I+1)-1
  KB(J)=I
$10 CONTINUE
$20 CONTINUE
  $ADD(SINID)
    CALL UXVSET(MMAX,ZERO,$B)
    NZA=MMAX
  $ENDADD
  CALL UXSIBS(NN,MM,$KB,$JB,$IW,NZA,$IW1,$IW2,NAU,IER)
  IF (IER.LT.0) THEN
  TXFU='LACK SPC'
  ITERM=IER
  GO TO $90
  ENDIF
  ENDIF
  CALL UXSLIN($N,M,$H,$IH,NX,$NN,MC,$CG,$ICG,$JCG,$KCG,$KX,NCA,$ICA&
,$D($N+1),$B,$IB)
*
*     BUNCH-PARLETT DECOMPOSITION
*
  CALL UXSIBF(NN,MM,$KB,$JB,$B,MMAX,$IW,NZA,$IW1,$IW2,NAU,NUP,IER)
  IF (IER.LT.0) THEN
  TDXX='LACK SPC'
  ITERM=IER
  GO TO $90
  ENDIF
  NDECF=NDECF+1
  IDECF=7
  CALL UXVCOP(NN,$GS,$S)
  CALL UXSIBB(NN,$B,MMAX,$IW,NZA,$XO,$S,$IW1,NAU,NUP)
*
*     NEWTON LIKE STEP
*
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  TDXX = 'B-P STEP'
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  IPOM=0
  KPOM=0
  RPF2=RPF1
  $SUBST('UDSLID')
  CALL UODLI4($N,NX,$NN,NCA,$D,$S($N+1),$XO($N+1),$GO($N+1),$GS($N+1))
$90 CONTINUE
  R=ZERO
  CALL UOD1D2($N,$G,$S)
  CALL UXVSET(NX,ZERO,XO)
  $ADD(INIT)
    NDXX='UDSLI1'
  $ENDADD
  $EXIT
