$INTERFACE UDSSQ3                                             97/12/01
$REM TU
  $H=HF
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    MAXIMUM NUMBER OF MINOR CYCLES
  $CHECK(MIQ,500,INT,4,NO)
  $HELP
    MAXIMUM NUMBER OF MAJOR CYCLES
  $CHECK(MAQ,500,INT,4,NO)
  $ADD(INTEGER,'\$LENL($MCOLS)\$PTL($MCOLS)')
  $ADD(INTEGER,'\$CNR($NZ)\$ORDR($MCOLS)\$ORDC($MCOLS)\$ORDL($MCOLS)')
  $ADD(INTEGER,'\$PTR($MCOLS)\$LENR($MCOLS)')
  $ADD(INTEGER,'\$LI($NUP)\$LJ($NUP)\$WN01($MCOLS)')
  $ADD(INTEGER,'\$BCOL($MCOLS)\$RNR($NZA)\$PRNR($MCOLS+1)')
  $ADD(INTEGER,'\$INBCOL($MCOLS)\$JH($M)\$IH($MCOLS+1)\$IX($MCOLS)')
  $ADD(INTEGER,'\$RIGHT($MCOLS)\$UP($MROWS)')
  $ADD(REAL,'\$CM($NUP)\$AU($NAU)\$A($NZA)')
  $ADD(REAL,'\$WR01($MCOLS)\$WR02($MCOLS)')
  $ADD(REAL,'\$LAM($MCOLS)\$ECG($MCOLS)\$FCG($MCOLS)\$RCG($MCOLS)')
  $ADD(REAL,'\$PV($MCOLS)\$HF($M)\$S($MCOLS)\$XO($MCOLS)\$GO($MCOLS)')
  $ADD(REAL,'\$XO($MCOLS)\$GO($MCOLS)')
  $ADD(REAL,'\$X($MCOLS)\$G($MCOLS)\$GF($MCOLS)')
  $ADD(REAL,'\$XL($MCOLS)\$XU($MCOLS)')
  $ADD(INTEGER,'\I\J')
  $ADD(REAL,'\FSAV')
  $ADD(REAL,'\UXVDOT')
  $ADD(SINID)
    CALL UXVSET(MCOLS,ZERO,LAM)
  $ENDADD
  CALL UOD1D1
*
*     COMPUTE PARAMETERS FF,G OF THE QUADRATIC MODEL
*     FIRST - SAVE F,GF,X - FUNCTION VALUE AND GRADIENT
*
  FSAV=F
  CALL UXVCOP(NF,$X,$XO)
  CALL UXVCOP(NF,$GF,$GO)
*
*     COMPUTE GF
*
  CALL UXSSMM(NF,$IH(NF+1)-1,$H,$IH,$JH,$X,$G)
  CALL UXVDIF(NF,$GF,$G,$G)
*
*     COMPUTE FF
*
  FF=F-0.5$P 0*(UXVDOT(NF,$X,$GF)+UXVDOT(NF,$X,$G))
*
*     CALL QP: PARAMETERS G AND GF ARE USED DIFFERENTLY
*
$REM  CALL UXVSET(N-NF,ZERO,G(NF+1))
$REM  CALL UXVSET(N-NF,ZERO,GF(NF+1))
  CALL UXVINS(MCOLS-NF,$IH(NF+1),$IH(NF+1))
  CALL UKQGLM(NF,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,MMAX,NEL,IBEG,IBGR&
,IENDLU,$PTL,$LENL,$CNR,$PTR,$LENR,$ORDC,$ORDR,$ORDL,$LI,$LJ,$CM,$AU&
,$LAM,$WR01,$X,$G,$GF,$HF,$JH,$IH,$BCOL,$RNR,$PRNR,$A,$INBCOL,$IX,$WN01&
,$WR02,$S,$XL,$XU,$ECG,$FCG,$RCG,$PV,$RIGHT,$UP,ALF1,ALF2,DEL1,DEL2&
,DEL3,EPS6,EPS7,EPS8,EPS9,RMIN,RMAX,DMAX,GMAX,UMAX,XMAX,GNORM,SNORM&
,XNORM,R,FF,F,FO,P,PO,T,TO,TL,TU,E,EL,EU,MFP,MQP,MQP1,MLP1,NIQ,NAQ,MRED&
,$MIQ,$MAQ,INEW,IOLD,KOLD,KINP,LINP,MINP,IER)
*
*     PREPARE LAM FOR COMPUTING GMAX,UMAX WITH NEW GRADIENT
*
  DO $50 I=LINP+1,N
  J=$BCOL(I)
  $LAM(I)=$LAM(I)-$GF(J)
$50 CONTINUE
*
*     COMPUTE DIRECTION, RETRIEVE VALUES
*
  CALL UXVDIF(NF,$X,$XO,$S)
  F=FSAV
  CALL UXVCOP(NF,$GO,$GF)
  CALL UXVCOP(NF,$XO,$X)
*
*     SNORM,GNORM COMPUTATION
*
  SNORM=ZERO
  GNORM=ZERO
  DO $10 I=1,NF
  SNORM=MAX(SNORM,ABS($S(I)))
  GNORM=MAX(GNORM,ABS($GF(I)))
$10 CONTINUE
*
*     UPDATE XMAX WHEN LINEAR CONSTRAINTS ARE PRESENT
*
  XMAX=HDEL
  DO $20 I=1,NF
  IF ($S(I).LT.0) THEN
  IF ($IX(I).LE.5.AND.$IX(I).GE.-4.AND.ABS($IX(I)).NE.2) THEN
  IF ((($X(I)+$S(I))-$XL(I)).LT.EPS9) THEN
  XMAX=MIN(XMAX,SNORM)
  GO TO $30
  ELSE
  XMAX=MIN(XMAX,SNORM*(ABS($X(I)-$XL(I))/ABS($S(I))))
  ENDIF
  ENDIF
  ELSE IF ($S(I).GT.0) THEN
  IF ($IX(I).LE.5.AND.$IX(I).GE.-4.AND.ABS($IX(I)).NE.1) THEN
  IF (($XU(I)-($X(I)+$S(I))).LT.EPS9) THEN
  XMAX=MIN(XMAX,SNORM)
  GO TO $30
  ELSE
  XMAX=MIN(XMAX,SNORM*(ABS($X(I)-$XU(I))/$S(I)))
  ENDIF
  ENDIF
  ENDIF
$20 CONTINUE
$30 CONTINUE
  ITERD=ITERQ
*
*     SET TDXX
*
  IF (ITERD.EQ.3) THEN
  TDXX='INEX. ST'
  ELSE IF (ITERD.EQ.2) THEN
  TDXX='OPT. QP '
  ELSE IF (ITERD.EQ.1) THEN
  TDXX='ARB. ST.'
  ELSE IF (ITERD.EQ.-1) THEN
  TDXX=TLPX
  ELSE IF (ITERD.EQ.-2) THEN
  TDXX='UNBND DR'
  ENDIF
  CALL UOD1D2(NF,$GF,$S)
  $ADD(INIT)
    NDXX='UDSSQ3'
  $ENDADD
  $EXIT
