$INTERFACE UDVLC1                                             97/12/01
$REM LU
  $CON1='0.10$P 0'
  $CON2='0.50$P 0'
  $CON3='0.10$P 0'
  $CON4='1.35$P 0'
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
  $ENDIF
  $HELP
    CHOICE OF THE CG METHOD
            0 - STEEPEST DESCENT
      -1 OR 1 - HESTENES AND STIEFEL
      -2 OR 2 - POLAK AND RIBIERE
      -3 OR 3 - FLETCHER AND REEVES
      -4 OR 4 - DAI AND YUAN
      -5 OR 5 - LIU AND STOREY
      -6 OR 6 - CONJUGATE DESCENT
      -7 OR 7 - HYBRID HU AND STOREY
      -8 OR 8 - HYBRID DAI AND YUAN
      -9 OR 9 - DESCENT HAGER AND ZHANG
      MET < 0 - PREVIOUS DIRECTION VECTOR IS USED
      MET > 0 - VECTOR OF VARIABLES DIFFERENCE IS USED
  $CHECK(MET,1,'-9\-8\-7\-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6\7\8\9',3)
  $NET=MET
  $IF(MET=-1) $NET=1
  $IF(MET=-2) $NET=2
  $IF(MET=-3) $NET=3
  $IF(MET=-4) $NET=4
  $IF(MET=-5) $NET=5
  $IF(MET=-6) $NET=6
  $IF(MET=-7) $NET=7
  $IF(MET=-8) $NET=8
  $IF(MET=-9) $NET=9
  $IF(NET=1) $CON2='1.0$P 0'
  $IF(NET=2) $CON2='1.0$P 0'
  $IF(NET=6) $CON1='5.0$P-2'
  $IF(NET=7) $CON1='5.0$P-2'
  $IF(NET=8) $CON1='5.0$P-2'
  $DEFAULT=2
  $IF(NET=1) $DEFAULT=3
  $IF(NET=2) $DEFAULT=3
  $IF(NET=5) $DEFAULT=3
  $HELP
    MODIFICATION OF THE CG METHOD
      1 - BASIC CG METHOD
      2 - CG METHOD WITH A POSITIVE PARAMETER
      3 - BOUNDED CG METHOD WITH A POSITIVE PARAMETER
  $CHECK(MET1,DEFAULT,'1\2\3',4)
  $DEFAULT=1
  $IF(NET=3) $DEFAULT=2
  $IF(NET=4) $DEFAULT=2
  $IF(NET=6) $DEFAULT=2
  $IF(NET=7) $DEFAULT=2
  $IF(NET=8) $DEFAULT=2
  $HELP
    TEST ON CONJUGACY OR ORTHOGONALITY
      1 - BASIC CG METHOD
      2 - CG METHOD WITH THE TEST ON CONJUGACY
      3 - CG METHOD WITH THE TEST ON ORTHOGONALITY
  $CHECK(MET2,DEFAULT,'1\2\3',4)
  $HELP
    SCALING OF THE CG METHOD
      1 - NO SCALING
      2 - BFGS SCALING IN EVERY ITERATION
      3 - DFP SCALING IN EVERY ITERATION
      4 - HOSHINO SCALING IN EVERY ITERATION
  $CHECK(MET3,1,'1\2\3\4',4)
  $HELP
    THE USE OF PERIODIC RESTARTS
      1 - PERIODIC RESTARTS AFTER    N ITERATIONS
      2 - PERIODIC RESTARTS AFTER  2*N ITERATIONS
      3 - PERIODIC RESTARTS AFTER 12*N ITERATIONS
  $CHECK(MET4,1,'1\2\3',4)
  $IF($DEF(KDS))
  $ELSE
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(KDE>0) $DEFAULT=1
    $IF(KDY>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
  $ENDIF
  $DEFAULT=4
  $IF(KDS=0) $DEFAULT=2
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,DEFAULT,'1\2\3\4\5',4)
  $DEFAULT=1
  $IF(MET4=2) $DEFAULT=2
  $IF(MET4=3) $DEFAULT=12
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,DEFAULT,INT,4)
  $DEFAULT=0
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,DEFAULT,INT,4)
  $DEFAULT='1.0$P-1'
  $IF(KDS=0) $DEFAULT='1.0$P-1'
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
  $CHECK(EPS1,DEFAULT,REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'1.0$P-1',REAL,4)
  $IF(MET<0)
    $XOS=XO
    $XO=SN
  $ENDIF
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\BET\GAM\DEL\DEN\POM\TMP')
  CALL UOD0D1(R,GNORM)
  ALF=GNORM*GNORM
  BET=UX$(POM1)DOT($N,$GN,$GN$POM2
  GNORM=SQRT(BET)
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) THEN
  TUXX='INITIAL '
  E=ONE
  GO TO $10
  ENDIF
*
*     DETERMINATION OF THE SCALING FACTOR
*
  $IF(MET3=1)
    $IF(MET<0)
      DEN=ONE
    $ELSE
      DEN=R
    $ENDIF
  $ELSE
    $IF(MET<0)
      DEN=E
    $ELSE
      DEN=R*E
    $ENDIF
    $IF(MET3=2)
      POM=UX$(POM1)DOT($N,$GO,$GO$POM2
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
      IF (POM.GT.ZERO) THEN
      E=DEL/POM
    $ELSEIF(MET3=3)
      TMP=UX$(POM1)DOT($N,$XO,$XO$POM2
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
      IF (DEL.GT.ZERO) THEN
      E=TMP/DEL
    $ELSE
      TMP=UX$(POM1)DOT($N,$XO,$XO$POM2
      POM=UX$(POM1)DOT($N,$GO,$GO$POM2
      IF (POM.GT.ZERO) THEN
      E=SQRT(TMP/POM)
    $ENDIF
    E=MIN(E,2.0$P 2)
    E=MAX(E,5.0$P-3)
    ELSE
    E=ONE
    ENDIF
  $ENDIF
*
*     CONJUGATE GRADIENT DIRECTION
*
  $IF(NET=0)
    TUXX='ST.DESC.'
    GO TO $10
  $ELSEIF(NET=1)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $IF(MET3=2)
    $ELSEIF(MET3=3)
    $ELSE
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
    $ENDIF
    IF (DEL.EQ.ZERO) THEN
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
    ELSE
    GAM=(TMP/DEL)
    TUXX='HEST.ST.'
    ENDIF
  $ELSEIF(NET=2)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
  $ELSEIF(NET=3)
    GAM=(BET/ALF)/DEN
    TUXX='FLET.RV.'
  $ELSEIF(NET=4)
    $IF(MET3=2)
    $ELSEIF(MET3=3)
    $ELSE
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
    $ENDIF
    IF (DEL.EQ.ZERO) THEN
    GAM=(BET/ALF)/DEN
    TUXX='FLET.RV.'
    ELSE
    GAM=(BET/DEL)
    TUXX='DAI YUAN'
    ENDIF
  $ELSEIF(NET=5)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    DEL=-PO
    IF (DEL.EQ.ZERO) THEN
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
    ELSE
    GAM=(TMP/DEL)
    TUXX='LIU STOR'
    ENDIF
  $ELSEIF(NET=6)
    DEL=-PO
    IF (DEL.EQ.ZERO) THEN
    GAM=(BET/ALF)/DEN
    TUXX='FLET.RV.'
    ELSE
    GAM=(BET/DEL)
    TUXX='CON.DES.'
    ENDIF
  $ELSEIF(NET=7)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    GAM=MIN(BET/ALF,TMP/ALF)/DEN
    $IF(MET1=1)
      GAM=MAX(GAM,-(BET/ALF)/DEN)
    $ENDIF
    TUXX='HU STOR.'
  $ELSEIF(NET=8)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $IF(MET3=2)
    $ELSEIF(MET3=3)
    $ELSE
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
    $ENDIF
    IF (DEL.EQ.ZERO) THEN
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
    ELSE
    GAM=MIN(BET/DEL,TMP/DEL)
    $IF(MET1=1)
      GAM=MAX(GAM,-(BET/DEL)*(ONE-EPS2)/(ONE+EPS2))
    $ENDIF
    TUXX='DAI YUAN'
    ENDIF
  $ELSEIF(NET=9)
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $IF(MET3=2)
    $ELSEIF(MET3=3)
    $ELSE
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
    $ENDIF
    IF (DEL.EQ.ZERO) THEN
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
    ELSE
    $IF(MET3=2)
    $ELSEIF(MET3=4)
    $ELSE
      POM=UX$(POM1)DOT($N,$GO,$GO$POM2
    $ENDIF
    GAM=TMP/DEL-2.0$P 0*(POM/DEL)*(P/DEL)
    $IF(MET1=1)
      GAM=MAX(GAM,-ONE/(DEN*SNORM*MIN(1.0$P-2,GNORM)))
    $ENDIF
    TUXX='HA.ZHANG'
    ENDIF
  $ELSE
    TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $IF(MET3=2)
    $ELSEIF(MET3=3)
    $ELSE
      DEL=UX$(POM1)DOT($N,$XO,$GO$POM2
    $ENDIF
    IF (DEL.EQ.ZERO) THEN
    GAM=(TMP/ALF)/DEN
    TUXX='POL.RIB.'
    ELSE
    GAM=MAX(TMP/DEL,ZERO)-$CON3*P/DEL
    TUXX='DAI LIAO'
    ENDIF
  $ENDIF
  $IF(NET=3)
  $ELSEIF(MET1=1)
  $ELSEIF(MET1=2)
    TDXX='POSIT CG'
    IF (GAM.LE.ZERO) THEN
    CALL UYRES1('NEGAT P.')
    GO TO $10
    ENDIF
  $ELSEIF(MET1=3)
    TDXX='BOUND CG'
    IF (GAM.LE.ZERO) THEN
    CALL UYRES1('NEGAT P.')
    GO TO $10
    ENDIF
    BET=(BET/ALF)/DEN
    IF (GAM.GT.$CON4*BET) THEN
    CALL UYRES1('LARGE P.')
    GO TO $10
    ENDIF
  $ENDIF
  CALL UX$(POM1)DIR($N,-GAM,$XO,$GN,$SN$POM2
  CALL UX$(POM1)NEG($N,$SN,$SN$POM2
*
*     SCALING THE DIRECTION VECTOR
*
  $IF(MET3=1)
  $ELSE
    CALL UXVSCL($N,E,$SN,$SN)
  $ENDIF
  SNORM=DSQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  $IF(MET2=2)
    TDXX='CONJ  CG'
    $IF(MET3=2)
    $ELSEIF(MET3=4)
    $ELSE
      POM=UX$(POM1)DOT($N,$GO,$GO$POM2
    $ENDIF
    IF (ABS(UX$(POM1)DOT($N,$SN,$GO$POM2).GT.$CON1*SQRT(POM)*SNORM)&
    THEN
    CALL UYRES1('NONCONJ.')
    GO TO $10
    ENDIF
  $ELSEIF(MET2=3)
    TDXX='ORTH  CG'
    $IF(NET=3)
      TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $ELSEIF(NET=4)
      TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $ELSEIF(NET=6)
      TMP=UX$(POM1)DOT($N,$GN,$GO$POM2
    $ENDIF
    IF (ABS(GNORM*GNORM-TMP).GT.$CON2*GNORM*SQRT(ALF)) THEN
    CALL UYRES1('NONORTH.')
    GO TO $10
    ENDIF
  $ENDIF
  GO TO $20
$10 ITERD=0
*
*     STEEPEST DESCENT DIRECTION
*
  CALL UX$(POM1)NEG($N,$GN,$SN$POM2
*
*     SCALING THE DIRECTION VECTOR
*
  $IF(MET3=1)
  SNORM=GNORM
  $ELSE
    CALL UXVSCL($N,E,$SN,$SN)
    SNORM=E*GNORM
  $ENDIF
  TDXX='ST.DESC.'
  CALL UYSET3
$20 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(MET<0)
    $XO=XOS
  $ENDIF
  $ADD(INIT)
    NDXX='UDVLC1'
  $ENDADD
  $EXIT
