$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UGFU21                                    01/12/98  +
$REM + SI                                                            +
$REM + PURPOSE: GLOBAL OPTIMIZATION  - TUNNELING METHOD              +
$REM +---------------------------------------------------------------+
      $SET(PENALFNC)
         IF (TUNEL) THEN
           $IF(KD=0)
             CALL UG0F01(NF,F,X,FSET(NLMIN),XSET((NLMIN-1)*NF+1),IALF)
           $ELSE
             CALL UG1F01(NF,F,X,FSET(NLMIN),XSET((NLMIN-1)*NF+1),$GF&
            ,ALF,KD)
           $ENDIF
         ENDIF
      $ENDSET
      $HELP
        MAX. NUMBER OF LOCAL MINIMA
      $CHECK(MNLMIN,'50+10*$NF',STR,3,NO)
      $HELP
        MAX. VALUE OF PARAMETER ALFA OF TUNNELING FUNCTION
      $CHECK(MAXALFA,8,INT,3,NO)
      $ADD(REAL,'\X($NF)\XL($NF)\XU($NF)\FSET($MNLMIN)&
           \XSET($NF*($MNLMIN))')
      $ADD(INTEGER,'\NLMIN\IALF')
      $ADD(LOGICAL,'\TUNEL')
      $TEXT='UGFU21'
      $SUBST('UO3FU1')
$L=$00; $LABEL
      CALL UGFU21(NF,X,XL,XU,FSET,XSET,TUNEL,NLMIN,IALF,F,FMIN)
      GOTO ($20,$10) ISB+1
$L=$10; $LABEL
      $SUBST('UZLMIN')
      GOTO $00
$L=$20; $LABEL
$ADD(SUBROUTINES)
      SUBROUTINE UGFU21(NF,X,XL,XU,FSET,XSET,TUNEL,NLMIN,IALF,F,FMIN)
      INTEGER NF,NLMIN,IALF
      $FLOAT X($NF),XL($NF),XU($NF),FSET($MNLMIN),XSET($NF*($MNLMIN)),
     &       F,FMIN
      LOGICAL TUNEL
      $INCLUDE('UMCOMM')
      $FLOAT FMIN2
      INTEGER MNLMIN,INDX($MNLMIN),I,NSTEP
      INTEGER NITT,NFVT,NFGT,NFHT,NLMST
      LOGICAL UYDMIN
      SAVE FMIN2
      SAVE MNLMIN,INDX,NSTEP,NITT,NFVT,NFGT,NFHT,NLMST
$REM      IF (NS.EQ.0.OR.TSS(NS).NE.'UGFX') THEN
      IF (NS.EQ.0) THEN
        CALL UYPRO1('UGFX',-1)
        NITT=0
        NFVT=0
        NFGT=0
        NFHT=0
        NLMST=0
        NLMIN=0
        NSTEP=1
        MNLMIN=$MNLMIN
        TUNEL=.FALSE.
        DO 10 I=1,NF
          X(I)=(XU(I)-XL(I))/2+XL(I)
   10   CONTINUE
      ENDIF
      GOTO (20,40), ISP(NS)
   20 CONTINUE
  *
  *     APPROPRIATE STEP FROM TUNEL. LOCAL MINIMUM
  *
      IF (TUNEL) THEN
        IF (NSTEP.GT.0) THEN
          X(NSTEP)=X(NSTEP)+(XU(NSTEP)-X(NSTEP))/($MAXALFA-IALF+1)
        ELSE
          X(-NSTEP)=X(-NSTEP)-(X(-NSTEP)-XL(-NSTEP))/($MAXALFA-IALF+1)
        ENDIF
      ENDIF
  *
  *     LOCAL OPTIMIZATION PHASE
  *
   30 CONTINUE
      FMIN2=FMIN
      IF (TUNEL) FMIN=0.0$P 0
  *
  *     LOCAL OPTIMIZATION
  *
      CALL UYCLST
      CALL UYSET0(1,2)
      RETURN
   40 CONTINUE
      NITT=NITT+NIT
      NFVT=NFVT+NFV
      NFGT=NFGT+NFG
      NFHT=NFHT+NFH
      NLMST=NLMST+1
      FMIN=FMIN2
      IF (TUNEL) THEN
        IF (F.GT.0) THEN
          IF (NSTEP.GT.0) THEN
            NSTEP=-NSTEP
          ELSEIF (NF+NSTEP.GT.0) THEN
            NSTEP=-NSTEP+1
          ELSEIF (IALF.LT.$MAXALFA) THEN
            IALF=IALF+1
            NSTEP=1
          ELSE
            GOTO 60
          ENDIF
          CALL UXVCOP(NF,XSET((NLMIN-1)*NF+1),X)
        ELSE
          TUNEL=.FALSE.
          GOTO 30
        ENDIF
      ELSE
        I=1
   50   CONTINUE
        IF (I.LE.NLMIN) THEN
          IF (UYDMIN(NF,F,X,FSET(I),XSET((I-1)*NF+1))) THEN
            I=I+1
            GOTO 50
          ENDIF
        ENDIF
        IF (I.GT.NLMIN.AND.ITERM.GE.1.AND.ITERM.LE.10) THEN
          NLMIN=NLMIN+1
          CALL UXVCOP(NF,X,XSET((NLMIN-1)*NF+1))
          FSET(NLMIN)=F
          CALL UO3FU4(NITT,NFVT,NLMIN,F)
          IF (NLMIN.EQ.MNLMIN) GOTO 60
          IALF=5
        ELSEIF(IALF.LT.$MAXALFA) THEN
          IALF=IALF+1
        ELSE
          GOTO 60
        ENDIF
        NSTEP=1
        TUNEL=.TRUE.
      ENDIF
      GOTO 20
  *
  *     PRINT OF RESULTS
  *
   60 CONTINUE
      CALL UYINDX(NLMIN,FSET,INDX)
      F=FSET(1)
      CALL UXVCOP(NF,XSET,X)
      NIT=NITT
      NFV=NFVT
      NFG=NFGT
      NFH=NFHT
      CALL UO3FU5(NF,NLMIN,MNLMIN,FSET,XSET,INDX)
      CALL UYEPI1(-1)
      END
$ENDADD
