$INTERFACE UULVP1                                             02/12/01
  $XR='XR'
  $GR='GR'
  $IF(MET5=4)
  $XX=XS
  $ADD(REAL,'\$XS(3*$NF)')
  $ELSEIF(MET5=6)
  $XX=XS
  $ADD(REAL,'\$XS(3*$NF)')
  $ELSE
  $XX=XO
  $ENDIF
  $GG=G
  $IF(CONSTR='C') $GG=SO
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - VARIATIONALLY DERIVED PRECONVEX UPDATE
  $CHECK(MET,1,'1\2\3\4\5',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,1,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      ABS(MET2)=1 - QUADRATIC MODEL
      ABS(MET2)=2 - BASIC USE OF TAYLOR EXPANSION
      ABS(MET2)=3 - MODIFIED USE OF TAYLOR EXPANSION
      ABS(MET2)=4 - HOMOGENEOUS MODEL
      ABS(MET2)=5 - CUBIC MODEL
           MET2>0 - BASIC VARIABLE METRIC UPDATE
           MET2<0 - MODIFIED VARIABLE METRIC UPDATE
  $CHECK(MET2,1,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $IF(MET= 1) $DEFAULT=1
  $IF(MET= 2) $DEFAULT=2
  $IF(MET= 3) $DEFAULT=3
  $IF(MET= 4) $DEFAULT=1
  $IF(MET= 5) $DEFAULT=3
  $IF(MET1=5) $DEFAULT=3
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
      4 - HARMONIC MEAN
      5 - ARITHMETIC MEAN
  $CHECK(MET4,DEFAULT,'1\2\3\4\5',4)
  $HELP
    LIMITED MEMORY METHOD:
      MET5=1 - RANK ONE LIMITED MEMORY METHOD
      MET5=2 - SIMPLE RANK TWO LIMITED MEMORY METHOD
      MET5=3 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM THE
               SHIFTED BROYDEN CLASS (SIMPLE CHOICE)
      MET5=4 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM THE
               SHIFTED BROYDEN CLASS (FROBENIUS NORM)
      MET5=5 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM THE
               SHIFTED BROYDEN CLASS (DIRECTION VECTOR)
      MET5=6 - RANK TWO LIMITED MEMORY METHOD DERIVED FROM THE
               STANDARD BROYDEN CLASS (FROBENIUS NORM)
  $CHECK(MET5,4,'0\1\2\3\4\5\6',4)
  $ADD(REAL,'\$XM($NF*$MF)\$XR($MF)\$GR($MF)\$XO($NF)\$GO($NF)&
  \$GS($NF)')
$REM  $ADD(INTEGER,'\NF\MF\INF')
  CALL UULVP1(NF,NN,$XM,$XR,$GR,$S,$XO,$GO,$XX,$GS,R,F,FO,P,PO&
,PAR,PAR1,PAR2,MET,MET1,MET2,MET3,MET4,MET5)
  $ADD(INIT)
    NUXX='UULVP1'
  $ENDADD
  $EXIT
